#!/usr/bin/perl

##########################################################################
#
#	Vote Tracker V1.1
#
#	Copyright 1998, Jim Melanson, Jim Melanson Web Design.
#
#	By configuring and or loading this script, you agree to indemnify
#	Jim Melanson and Jim Melanson Web Design from any loss or damage,
#	however caused, including but not limited to negligence, error,
#	misconfiguration, abuse. If the laws governing your local area
#	do not allow such a limitation of exclusion then you do not
#	have my permission to use this script.
#
#	You may not alter or change this script in any way whatsoever
#	without written permission from the author.
#
#	All credit and copyright notices must remain intact and
#	un-altered.
#
##########################################################################
#	Directions:
#
#	1) Set the three variables below according to the accompanying
#		notations.
#
#	2) Load and CHMOD this script to 755.
#
#	3) The first time you run this program run:
#	    http://www.yourdomain.com/cgi-bin/path/to/vote.pl?setup
#	   At the presented page, enter a UserID and Password(twice) then
#	   enter a keyword. The keyword is anyword that will help you find
#	   a forgotten UserID or Password. After setup, enter the keyword
#	   in the UserID and Password form on the admin page and you will
#	   be presented with your current UserId and Password.
#
#	   NOTE: This script reads your server on setup and creates it's
#	   own data structure according to what is on the server. You do
#	   not have to create any data directories, the program does it
#	   for you.
#
#	4) To add or remove an item from the voting list, enter the URL:
#	    http://www.yourdomain.com/cgi-bin/path/to/vote.pl?admin
#	   Then just follow the directions on the page to add or remove
#	   items. This page will also display all the items in the voting
#	   list along with the associated reference number.
#
#	5) For the items to be voted upon, after entering their name, you
#	   will be presented with HTML that you can cut and paste to set up
#	   the link for that item. The program generates a unique ID number
#	   for each item. The HTML link generated will be the full URL of the
#	   program, followed by:   ?vote##   where ## is the unique number.
#	   An example of this link would be:
#      <A HREF="http://www.yourdomain.com/cgi-bin/path/to/vote.pl?vote26">
#				Sausages</A>
#
#
#		That's all there is to it. Load the script and play with
#		it, you can see it in action on the charity_ware site at:
#
#		 www.thebeaches.to/jmwd/charity_ware/my_vote_tracker.html
#
##########################################################################

$AdminEmail = "yourname\@yourdomain.com";
#This is your e-mail address. Don't forget to escape the @ symbol by
#putting a backslash in front of it.

$SiteName = "Charity Ware";
#Name of your site.

$Choice = "Script Names";
#A contextual thing really. If you voting on bands, put in "bands" etc.

##########################################################################
#			TOUCH NOTHING BELOW THIS LINE
##########################################################################

&Parse;
&Date;

print "Content-type: text/html\n\n";

$ScriptURL = "http://$ENV{'SERVER_NAME'}$ENV{'SCRIPT_NAME'}";
$tempdata = $ENV{'DOCUMENT_ROOT'};
if($tempdata =~ /\n$/) {
    chop($tempdata);
}
$Data = "$tempdata/jmcw_logs/vote_v1";

if($ENV{'QUERY_STRING'} =~ /^vote(\d{1,})/) {
    $TempSubject = $1;
    &Vote($TempSubject);
}
elsif($ENV{'QUERY_STRING'} eq 'setup') {&Setup}
elsif($ENV{'QUERY_STRING'} eq 'admin') {&Admin}
else {
    $Problem = "you attempted to call the script incorrectly. Please try again.";
    &Error($Problem);
}
exit;

##########################################################################

sub Vote {
    local($Subject) = @_[0];
    local($TOTAL_VOTES) = 0;
    local($count_check) = 0;

    open(VOTE, "<$Data/votes.list");
    flock(VOTE, '1');
    @Contents = <VOTE>;
    close(VOTE);
    open(NEWVOTE, ">$Data/votes.list");
    flock(NEWVOTE, '2');
    foreach $content (@Contents) {
	chop($content);
	($Votecount, $Votename, $Votenum, $AddDate) = split(/\t/, $content);
	$TOTAL_VOTES = $TOTAL_VOTES + $Votecount;
	if(int($Votenum) == int($Subject)) {
	    $Votecount++;
	    print NEWVOTE "$Votecount\t$Votename\t$Votenum\t$AddDate\n";
	    $count_check = 1;
	}
	else {print NEWVOTE "$content\n"}
    }
    close(NEWVOTE);

    if($count_check) {
	&PrintHead;
        print "<H2 align=\"center\">Summary of Voting Results</H2><HR><CENTER>\n";
        print "<P><TABLE><TR><TD><SMALL><B>Score &nbsp;</B></SMALL></TD><TD><B><SMALL>&nbsp; Votes</SMALL></B></TD><TD ALIGN=\"CENTER\"><SMALL><B>$Choice</B></SMALL></TD></TR>\n";
        open(VOTE, "<$Data/votes.list");
	flock(VOTE, '1');
        @List = <VOTE>;
        close(VOTE);
    	@Contents = sort {$b <=> $a} @List;
        foreach $content (@Contents) {
	    chop($content);
	    ($Votecount, $Votename, $Votenum, $AddDate) = split(/\t/, $content);
	    $PERCENTAGE = int(($Votecount / $TOTAL_VOTES) * 100);
	    if(int($Votenum) == int($Subject)) {
		print "<TR BGCOLOR=\"#FAFAD2\"><TD ALIGN=\"CENTER\"><SMALL><B>$PERCENTAGE%</B></SMALL></TD><TD ALIGN=\"CENTER\"><SMALL><U>$Votecount</U></SMALL></TD><TD><SMALL>$Votename</SMALL></TD></TR>\n";
	    }
	    else {
		print "<TR><TD ALIGN=\"CENTER\"><SMALL>$PERCENTAGE%</SMALL></TD><TD ALIGN=\"CENTER\"><SMALL>$Votecount</SMALL></TD><TD><SMALL>$Votename</SMALL></TD></TR>\n";
	    }
	}

        print "</TABLE><BR><BR><BR>Please use the back<BR>button on your browser.</CENTER><P>\n";
        &PrintFoot;
    }
    else {
	$Problem = "it appears that the link you pressed referenced " .
	    "a non-existent item. Please notify <A HREF=\"mailto:$AdminEmail\">the webmaster</a> " .
	    "so that this can be corrected";
	&Error($Problem);
    }
}

sub Admin {
    if($FORM{'action'} eq 'add') {
      if(&CheckPass($FORM{'user'}, $FORM{'pass'})) {
	$AddName = $FORM{'addchoice'};
	open(READ, "<$Data/votes.list");
	flock(READ, '1');
	@Contents = <READ>;
	close(READ);
	$num = @Contents;
	$num--;
	chop($Contents[$num]);
	($Votecount, $Votename, $Votenum, $AddDate) = split(/\t/, $Contents[$num]);
        $NextNum = $Votenum + 7;
	open(WRITE, ">>$Data/votes.list");
	print WRITE "1\t$AddName\t$NextNum\t$date\n";
	close(WRITE);
	&PrintHead;
	print "<H2>Successful Addition -</H2><HR><B><CENTER>The choice\n";
	print "<I>$AddName</I> has been successfully added to the database.\n";
	print "Here is the new link you must specify to vote for $AddName.\n";
	print "If you chose, substitute the text link with a graphic.<P>\n";
	print "<CENTER><BIG><TT>&lt;A HREF=\"$ScriptURL?vote$NextNum\"&gt;$AddName&lt;/A&gt;</TT></BIG>\n";
	print "</CENTER></B><BR><BR><BR>Back to <A HREF=\"$ScriptURL?admin\">Admin Page</A><BR><BR><BR>\n";
	&PrintFoot;
      }
      else {
	$Problem = "the Password or UserID you entered do not match " .
	    "the database.";
	&Error($Problem);
      }
    }
    elsif($FORM{'action'} eq 'remove') {
        if(&CheckPass($FORM{'user'}, $FORM{'pass'})) {
          if(!$FORM{'removechoice'}) {
		$Problem = "you forgot to enter a reference number";
		&Error($Problem);
	  }
	  else {
	    $Remove_Choice = $FORM{'removechoice'};
	    open(READ, "<$Data/votes.list");
	    flock(READ, '1');
	    @Contents = <READ>;
	    close(READ);
	    $num = @Contents;
	    open(WRITE, ">$Data/votes.list");
	    flock(WRITE, '1');
	    for($a = 0; $a < $num; $a++) {
	        chop($Contents[$a]);
	        ($Votecount, $Votename, $Votenum, $AddDate) = split(/\t/, $Contents[$a]);
	        unless($Votenum eq $Remove_Choice) {
		    print WRITE "$Contents[$a]\n";
	        }
	    }
	    close(WRITE);
	    &PrintHead;
	    print "<H2>Successful Deletion -</H2><HR><B><CENTER>\n";
	    print "<P><A HREF=\"$ScriptURL?admin\">Return to Admin Page</A>\n";
	    print "</CENTER></B><BR><BR><BR><BR><BR><BR>\n";
	    &PrintFoot;  
	  }
 	}
        else {
	    $Problem = "the Password or UserID you entered do not match " .
	        "the database.";
	    &Error($Problem);
        }
    }
    else {
	&PrintHead;
	print "<H2>Vote Tracker Admin Page -</H2><HR><B>\n";
	print "Welcome to Vote Tracker V1.1. To add a new choice for\n";
	print "voting, enter the name and then press the add\n";
	print "button:<P><FORM ACTION=\"$ScriptURL?admin\" METHOD=\"POST\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"add\">\n";
	print "<CENTER>Item Name:<BR><INPUT TYPE=\"TEXT\" NAME=\"addchoice\" SIZE=30><P>\n";
	print "User:<INPUT TYPE=\"TEXT\" NAME=\"user\" SIZE=20><BR>\n";
	print "Pass:<INPUT TYPE=\"PASSWORD\" NAME=\"pass\" SIZE=20><BR>\n";
	print "<INPUT TYPE=\"SUBMIT\" VALUE=\"Add Name\"></FORM><BR><HR><BR>\n";
	print "To remove a choice, enter the choices reference number\n";
	print "(from <B>the list</B> below) and press the button:<P><FORM ACTION=\"$ScriptURL?admin\" METHOD=\"POST\">\n";
	print "<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"remove\">\n";
	print "<CENTER>Reference #:<BR><INPUT TYPE=\"TEXT\" NAME=\"removechoice\" SIZE=8><P>\n";
	print "User:<INPUT TYPE=\"TEXT\" NAME=\"user\" SIZE=20><BR>\n";
	print "Pass:<INPUT TYPE=\"PASSWORD\" NAME=\"pass\" SIZE=20><BR>\n";
	print "<INPUT TYPE=\"SUBMIT\" VALUE=\"Remove\"></FORM><BR><HR><BR>\n";
	print "<CENTER><H3>Current Items Listed</H3><TABLE BORDER=2>\n";
	print "<TR><TD><SMALL><B>Ref #</B></SMALL></TD><TD><SMALL><I>Name</I></SMALL></TD><TD><SMALL>Date Added</SMALL></TD><TD><SMALL>Total Votes</SMALL></TD></TR>\n";
	    open(READ, "<$Data/votes.list");
	    flock(READ, '1');
	    @List = <READ>;
	    close(READ);
    	    @Contents = sort {$b <=> $a} @List;
	    $num = @Contents;
	    for($a = 0; $a < $num; $a++) {
	        chop($Contents[$a]);
	        ($Votecount, $Votename, $Votenum, $AddDate) = split(/\t/, $Contents[$a]);
		print "<TR><TD><SMALL><B>$Votenum</B></SMALL></TD><TD><SMALL><I>$Votename</I></SMALL></TD><TD><SMALL>$AddDate</SMALL></TD><TD ALIGN=\"CENTER\"><SMALL>$Votecount</SMALL></TD></TR>\n";
	    }
	print "</TABLE></CENTER><BR><BR><BR><BR>\n";
	&PrintFoot;
    }
}

sub Date {
        ($Second, $Minute, $Hour, $DayOfMonth, $Month, $Year, $Weekday,
	    $DayOfYear, $IsDST) = localtime(time);

        @ShowDay = ('Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday',
		'Friday', 'Saturday');
	@ShowMonth = ('January', 'February', 'March', 'April', 'May',
		'June', 'July', 'August', 'September', 'October',
		'November', 'December');

	if(($DayofMonth eq '1') || ($DayofMonth eq '21') || ($DayofMonth eq '31')) {
	    $ending = "st";
	}
	elsif(($DayofMonth eq '2') || ($DayofMonth eq '22')) {
	    $ending = "nd";
	}
	elsif(($DayofMonth eq '3') || ($DayofMonth eq '23')) {
	    $ending = "rd";
	}
	else {$ending = "th"}

        $RealYear = $Year + 1900;
        $date = "$ShowDay[$Weekday], $ShowMonth[$Month] $DayOfMonth<SUP>$ending</SUP>, $RealYear.";
}

sub Parse {
    local($name, $value, $buffer, $pair, $hold, @pairs);

    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
    @pairs = split(/&/, $buffer);
    foreach $pair (@pairs) {
	($name, $value) = split(/=/, $pair);
	$value =~ tr/+/ /;
	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	$value =~ s/\n//g;

	$value =~ s/<!--(.|\n)*-->//g;
	$value =~ s/<!--#[^>]+>//g;
	$value =~ s/<!.+>//g;
	$value =~ s/<\w.+?>|<\/\w.+?>//g;
	$value =~ s/<([^>]|\n)*>//g;
	$value =~ s/\s-\w.+//g;
	$value =~ s/system\(.+//g;
	$value =~ s/grep//g;
	$value =~ s/\srm\s//g;
	$value =~ s/\srf\s//g;
	$value =~ s/\.\.([\/\:]|$)//g;
	$value =~ s/< *((SCRIPT)|(APPLET)|(EMBED))[^>]+>//ig;

	$name =~ s/<!--(.|\n)*-->//g;
	$name =~ s/<!--#[^>]+>//g;
	$name =~ s/^<!.+>//g;
	$name =~ s/<\w.+?>|<\/\w.+?>//g;
	$name =~ s/<([^>]|\n)*>//g;
	$name =~ s/^\s-\w.+//g;
	$name =~ s/system\(.+//g;
	$name =~ s/grep//g;
	$name =~ s/\srm\s//g;
	$name =~ s/\srf\s//g;
	$name =~ s/\.\.([\/\:]|$)//g;
	$name =~ s/< *((SCRIPT)|(APPLET)|(EMBED))[^>]+>//ig;

	$FORM{$name} = $value
    }
    return(1);
}


sub CheckPass {
    local($CheckName, $CheckPass, $Name, $Pass);
    local($TheLine, $CompareName, $ComparePass);
    $CheckUser = @_[0];
    $CheckPass = @_[1];

    $salt = substr($CheckPass, 0, 2);
    $User = crypt($CheckUser, $salt);
    $Pass = crypt($CheckPass, $salt);

  if(($FORM{'user'}) && ($FORM{'pass'})) {
    if(($User eq $Pass) && (($User ne '') && ($Pass ne ''))) {
 	if(open(FIND, "<$Data/find.list")) {
	    $TheLine = <FIND>;
	    close(FIND);
	    chop($TheLine);
	    ($FindKeyword, $FindUser, $FindPass) = split(/\t/, $TheLine);
	    if($FindKeyword eq $User) {
		&PrintHead;
		print "<H2>Successful Retrieval -</H2><B><CENTER>\n";
		print "The information has been retrieved.<BR><BR><BR>\n";
		print "Your UserID is: <I>$FindUser</I><P>\n";
		print "Your Password is: <I>$FindPass</I><BR><BR><BR><BR>\n";
		&PrintFoot;
		return(0);
	    }
	    else {
		$Problem = "the keyword you entered does not match the " .
		    "records. Please try again.";
		&Error($Problem);
		return(0);
	    }
	}
	else {
	    $Problem = "the program could not read the keyword file.";
	    &Error($Problem);
	    return(0);
	}
    }
    else {
    	if(open(PASS, "<$Data/pass.list")) {
    	    $TheLine = <PASS>;
    	    close(PASS);
    	    chop($TheLine);
    	    ($CompareUser, $ComparePass) = split(/\t/, $TheLine);

    	    if(($User eq $CompareUser) && ($Pass eq $ComparePass)) {
	        return(1);
    	    }
	    else{return(0)}
	}
	else {
	    $Problem = "the program could not read the pass file.";
	    &Error($Problem);
   	    return(0);
	}
    }
  }
}


sub Error {
    local($cause) = @_[0];
    &PrintHead;
    print "<H2>Error -</H2><HR><CENTER><B>An error has occured.<P>The error\n";
    print "occured because $cause<P>Please use the back button on your\n";
    print "browser and try again.<P>Thank You.</CENTER>\n";
    &PrintFoot;
}

sub PrintHead {
    print "<HEAD><TITLE>$SiteName - Vote!</TITLE></HEAD><BODY\n";
    print "TEXT=\"BLACK\" LINK=\"#8B0000\" ALINK=\"#FF0000\"\n";
    print "VLINK=\"#B22222\" BGCOLOR=\"#FFF6FO\"><SMALL>\n";
    print "<FONT FACE=\"arial,verdana\">\n";
}

sub PrintFoot {
    print "<BR><BR><CENTER><SMALL><A HREF=\"http://www.thebeaches.to/\n";
    print "jmwd/index.html\">&copy; 1998, Jim Melanson Web Design</A>\n";
    print "<BR>Script Protection by<BR><A HREF=\"http://www.thebeaches.to\n";
    print "/jmwd/charity_ware/attack_guard.html\">Attack Guard V1.1(Modified)</A>\n";
    print "</SMALL></CENTER></FONT></SMALL></BODY></HTML>\n";
}

sub Setup {
    if(open(CHECK, "<$Data/pass.list")) {
	$Problem = "the program is already set up.";
	&Error($Problem);
    }
    elsif($FORM{'action'} eq 'setup') {
	if($FORM{'newpass'} eq $FORM{'newcompare'}) {
	    unless(-e "$ENV{'DOCUMENT_ROOT'}/jmcw_logs") {
		mkdir("$ENV{'DOCUMENT_ROOT'}/jmcw_logs", 0777);
		redirect_html("$ENV{'DOCUMENT_ROOT'}/jmcw_logs");
	    }
	    unless(-e "$ENV{'DOCUMENT_ROOT'}/jmcw_logs/vote_v1") {
		mkdir("$ENV{'DOCUMENT_ROOT'}/jmcw_logs/vote_v1", 0777);
		redirect_html("$ENV{'DOCUMENT_ROOT'}/jmcw_logs/vote_v1");
	    }


	    $salt = substr($FORM{'newpass'}, 0, 2);
	    $User = crypt($FORM{'newuser'}, $salt);
	    $Pass = crypt($FORM{'newpass'}, $salt);
	    $Find = crypt($FORM{'newfind'}, $salt);
	    open(PASS, ">$Data/pass.list") || die "Can't write pass file\n";
	    print PASS "$User\t$Pass\n";
	    close(PASS);
	    open(FIND, ">$Data/find.list") || die "Can't write pass file\n";
	    print FIND "$Find\t$FORM{'newuser'}\t$FORM{'newpass'}\n";
	    close(FIND);
	    open(WRITE, ">>$Data/votes.list");
	    print WRITE "1\tremove this item\t5\t$date\n";
	    close(WRITE);
	    &PrintHead;
	    print "<H2>Successful Setup -</H2><HR><B><CENTER>Your UserID\n";
	    print "and Password have been successfully setup. You may now\n";
	    print "begin <A HREF=\"$ScriptURL?admin\">adding choices</A> to the\n";
	    print "voting list.<BR><BR><BR><BR>\n";
	    &PrintFoot;
	}
	else { 
	    $Problem = "the two passwords did not match. Please try again.";
	    &Error($Problem);
	}
    }
    else {
&PrintHead;
print <<EndOfTop;

<CENTER><FORM ACTION=\"$ScriptURL?setup\" METHOD=\"POST\">
<INPUT TYPE=\"HIDDEN\" NAME=\"action\" VALUE=\"setup\">
Name:<INPUT TYPE=\"TEXT\" NAME=\"newuser\" SIZE=20><BR>
Pass:<INPUT TYPE=\"TEXT\" NAME=\"newpass\" SIZE=20><BR>
Compare:<INPUT TYPE=\"TEXT\" NAME=\"newcompare\" SIZE=20><P>
The keyword allows you to find<BR>your UserID and Password if you<BR>
forget them. Just enter the<BR>keyword twice in the UserID<BR>
and Password fields of the<BR>admin page and submit the form.<BR>
Keyword:<INPUT TYPE=\"TEXT\" NAME=\"newfind\" SIZE=20><P>
<INPUT TYPE=\"SUBMIT\" VALUE=\"SETUP\"></FORM></BODY></HTML>
EndOfTop
&PrintFoot;
    }
}

sub redirect_html {
    my($redirect_html_dir) = $_[0];
    my($redirect_file_name) = $_[1];
    if(!$redirect_file_name) {
	$redirect_file_name = "index.html";
    }
    if(open(HTML, ">$redirect_html_dir/$redirect_file_name")) {
    	print HTML "<HTML><HEAD><TITLE>Unauthorized Directory Access</TITLE></HEAD>\n";
    	print HTML "<BODY LINK=\"#8B0000\" ALINK=\"#FF0000\" VLINK=\"#B22222\" BGCOLOR=\"#FFF6FO\">\n";
    	print HTML "<CENTER><H2>Unauthorized Directory Access Request</H2>\n";
    	print HTML "<B><BLOCKQUOTE>The directory you have tried to enter<BR>\n";
    	print HTML "is not authorized for direct access. <P>\n";
    	print HTML "Please use the back button on your browser<BR>\n";
    	print HTML "to return to the page you came from.\n";
    	print HTML "</BLOCKQUOTE></B><BR><BR><BR><BR><BR><BR><BR><BR>\n";
    	print HTML "<A HREF=\"http://www.thebeaches.to/jmwd/index.html\"><SMALL>&copy; 1999-2000, Jim Melanson</SMALL></A>\n";
    	print HTML "</CENTER></BODY></HTML>\n";
	close(HTML);
	return(1);
    } else {
	return(0);
    }
}